
#include <stdio.h>
#include <string.h>
#include "queue.h"

// Notkun: split(q,q1,q2);
// Fyrir:  q1 og q2 eru tómar biðraðir, sem hver um sig
//         hefur pláss fyrir helming gilda úr q (þ.e.
//         fyrir (queue_count(q)+1)/2 gildi).
// Eftir:  Búið er að fjarlægja öll gildi úr q og setja 
//         helming þeirra í q1 og hinn helminginn í q2
//         (það gæti munað einum í fjölda staka, ef
//         fjöldinn er oddatala).
static void split(struct queue *q, struct queue *q1, struct queue *q2)
{
	// ...
}

// Notkun: merge(q1,q2,q);
// Fyrir:  q er tóm biðröð, q1 og q2 eru biðraðir, sem
//         innihalda gildi, sem eru í vaxandi röð frá 
//         fremsta til aftasta.
//         q hefur pláss fyrir öll gildin í q1 og q2.
// Eftir:  q1 og q2 eru tómar, gildin úr þeim eru í q í
//         vaxandi röð frá fremsta til aftasta.
void merge(struct queue *q1, struct queue *q2, struct queue *q)
{
	// ...
}

// Notkun: msort(q);
// Fyrir:  Ekkert
// Eftir:  Búið er að raða q í vaxandi röð
void msort(struct queue *q)
{
	if (queue_count(q) < 2)
		return;

	struct queue q1;
	struct queue q2;

	queue_init(&q1);
	queue_init(&q2);

	split(q, &q1, &q2);

	msort(&q1);
	msort(&q2);

	merge(&q1, &q2, q);
}

int main(void)
{
	char line[4096];
	struct queue q;
	char *p;

	queue_init(&q);

	while (1)
	{
		if (fgets(line, sizeof(line), stdin) == NULL)
			break;

		if ((p = strchr(line, '\n')))
			*p = 0;

		queue_put(&q, strdup(line));
	}

	msort(&q);

	while (!queue_empty(&q))
		printf("%s\n", queue_get(&q));

	return 0;
}

