
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "queue.h"

void queue_init(struct queue *q)
{
	q->head = NULL;
	q->tail = NULL;
	q->n = 0;
}

void queue_put(struct queue *q, char *value)
{
	struct item *p = malloc(sizeof(struct item));

	p->value = value;
	p->next = NULL;

	if (q->tail == NULL)
		q->head = p;
	else
		q->tail->next = p;

	q->tail = p;
	q->n++;
}

char *queue_get(struct queue *q)
{
	char *value = q->head->value;
	struct item *old = q->head;

	q->head = q->head->next;
	free(old);

	if (q->head == NULL)
		q->tail = NULL;

	q->n--;

	return value;
}

int queue_empty(struct queue *q)
{
	return q->n == 0;
}

int queue_count(struct queue *q)
{
	return q->n;
}

char *queue_peek(struct queue *q)
{
	return q->head->value;
}

