#ifndef __QUEUE_H
#define __QUEUE_H

struct item
{
	char *value;
	struct item *next;
};

struct queue
{
	// Ef biðröðin er tóm þá er head==tail==null og n==0.
	// Annars bendir head á hlekk (struct item) sem inniheldur
	// fremsta gildið og last bendir á hlekk sem inniheldur aftasta
	// gildið og milli þeirra eru hin gildin, tengd saman
	// á hefðbundinn hátt fyrir eintengdan lista.
	// Breytan n inniheldur ávallt fjölda gilda í listanum.

	struct item *head;
	struct item *tail;
	int n;
};

extern void queue_init(struct queue *q);
extern void queue_put(struct queue *q, char *value);
extern char *queue_get(struct queue *q);
extern int queue_empty(struct queue *q);
extern int queue_count(struct queue *q);
extern char *queue_peek(struct queue *q);

#endif
